function InpaintingDetection(path1, GDpath, path2, type, blocksize, thr1, ser1)
% path1: Full Path of File Directionary
% type:  Image type. ex. 'bmp', 'jpg' i.e. extension filename
% blocksize:  The frame will be paritioned to blocksize*blocksize
% thr1:  Exceeded this value denotes that there exists inpainting in this
% region.
addpath('FitFunc')
dirx = dir([path1 '*.' type]);
diry = dir([path2 '*.' type]);
len1 = length(dirx);
if (len1==0), return; end
img = imread([path1 dirx(1).name]);
[row, col, c]=size(img);
offset = blocksize-1;
colorNum = 1;

if (exist([path2 'detected\'], 'dir'))
        mkdir([path2 'detected\']);
end

avgPN=zeros(row, col);
pct = 0;
for i=ser1(1):ser1(end)
    a1=double(imread([path1 num2str(i) '.bmp']));
    for c=1:colorNum
        a1x=double(a1(:,:,c));
        avgPN = avgPN + a1x;
    end
    pct=pct+1;
end
avgPN = avgPN / (colorNum*(pct));
avgPN = denoise(avgPN) - avgPN;

a1=imread([path1 num2str(ser1(1)) '.bmp']);
pnu = zeros(row, col);
for c=1:colorNum
    b1=denoise(a1(:,:,c));
    b1 = b1-double(a1(:,:,c)); %N=PN+RN
    pnu = pnu + b1;
end
prvpnu = pnu / colorNum;

detectionRate = 0; falseAlarmRate = 0;errct = 1;
nimg=[]; nprv=[];
for i=ser1(2):ser1(end)  %2:len1-1 % all video frames, previous and next frames will be calculated

    a1=imread([path1 num2str(i) '.bmp']);
    g1 = rgb2gray(a1);
    a1 = double(a1);
    pnu = zeros(row, col);
    for c=1:colorNum
        b1=denoise(a1(:,:,c));
        b1 = b1-double(a1(:,:,c)); %N=PN+RN
        pnu = pnu + b1;
    end
    pnu = pnu / colorNum;

    
    rs =  imread([path2 num2str(i) '.' type]);
    img = imread([path1 num2str(i) '.' type]);
    img = img(:,:,1);
    GD = imread([GDpath num2str(i) '.' type]);
    GD = im2bw(GD);

    %calculating pattern noise in each block
    detectedImg = zeros(row, col); detectedImg=logical(detectedImg);
    for y=blocksize+1:blocksize:row-offset*2
        for x=blocksize+1:blocksize:col-offset*2
            rx = y:y+offset;
            ry = x:x+offset;
            
            gray = mean2(img(y:y+offset, x:x+offset));
            cr1 = corr2(prvpnu(rx,ry), pnu(rx, ry));  %N=PN+RN

            if (cr1>thr1  && gray<235 && gray>20) % fogeried region
                rs(y:y+offset, x,3)= 255;
                rs(y:y+offset, x+offset, 3)=255;
                rs(y, x:x+offset,3)=255;
                rs(y+offset, x:x+offset, 3)=255;
                rs(y:y+offset, x,1:2)= 0;
                rs(y:y+offset, x+offset, 1:2)=0;
                rs(y, x:x+offset,1:2)=0;
                rs(y+offset, x:x+offset, 1:2)=0;
                detectedImg(y:y+offset, x:x+offset)=1;
            end
        end
    end
    prvpnu = pnu;

    
    pos1 = find(GD==1);
    dr = sum(sum(detectedImg(pos1)))*100/(length(pos1));
    detectionRate = detectionRate + dr;
    pos1 = find(GD==0);
    err = sum(sum(detectedImg(pos1)))*100/(length(pos1));
    falseAlarmRate=falseAlarmRate+err;

    clc;

    imwrite(rs, [path2 'detected\' num2str(i) '.jpg']);
    disp(['Frame - ' num2str(i) '/' num2str(length(ser1))]);
    disp(['Detection rate - ' num2str(detectionRate/errct) ' / False alarm rate - ' num2str(falseAlarmRate/errct)]);
    errct=errct+1;
end