close all;

% Detection block size
bksize = 16;
offset = bksize-1;
colorNum = 3;
close all;
prefix = '..\test4';
%==========================================================================
% Parameters setting
% Path1: inpainted frame; Path2: ground truth indicating which region were
% removed.
%==========================================================================
path2 = [prefix '\removed\'];
path1 = [prefix '\completed\'];
dirx = dir([path1 '*.bmp']);
type = 'bmp';
len1 = length(dirx);
pst = 1; pet=len1-5;  % Start point and end point

calCorr;

%==========================================================================
% Calculating the probility
% pn: the correlation between PN & current frame noise pattern for
% inpainted region. pn3: the correlation between previous frame noise pattern
% & current frame noise pattern for inpainted region.
%
% pn2: the correlation between PN & current frame noise pattern for
% normal region. pn4: the correlation between previous frame noise pattern
% & current frame noise pattern for normal region.
%==========================================================================
pn(isnan(pn))=[];
pn2(isnan(pn2))=[];
pn2(isnan(pn2))=[];
pn2(isnan(pn2))=[];
[h1, h11]=hist(pn, 100);
[h2, h22]=hist(pn2, 100);
[h3, h33]=hist(pn3, 100);
[h4, h44]=hist(pn4, 100);



% Show the hsitogram

figure(1), plot(h11, h1, 'b-');
hold on;
figure(1), plot(h22, h2, 'r-');

figure(2), plot(h33, h3, 'b-');
hold on;
figure(2), plot(h44, h4, 'r-');

w1 = numel(pn) / (numel(pn2)+numel(pn));
thr1 =  0.5*(max(h33) + max(h44));

path3 = [prefix '\Original\'];
InpaintingDetection(path1, path2, path3, type, bksize, thr1, [pst+5:pet-5]);

