function rs = denoise(data)

% Perform wavelet transform using Daubechies filter bank, 4th order
% decomposition
[LL1,HL1,LH1,HH1] = dwt2(data,'db1');
[LL2,HL2,LH2,HH2] = dwt2(LL1,'db1');
[LL3,HL3,LH3,HH3] = dwt2(LL2,'db1');
[LL4,HL4,LH4,HH4] = dwt2(LL3,'db1');

% MAP estimation in each wavelet coefficients (only high-frequency)
HL1 = fastInnerDenoise(HL1);
HL2 = fastInnerDenoise(HL2);
HL3 = fastInnerDenoise(HL3);
HL4 = fastInnerDenoise(HL4);
LH1 = fastInnerDenoise(LH1);
LH2 = fastInnerDenoise(LH2);
LH3 = fastInnerDenoise(LH3);
LH4 = fastInnerDenoise(LH4);
HH1 = fastInnerDenoise(HH1);
HH2 = fastInnerDenoise(HH2);
HH3 = fastInnerDenoise(HH3);
HH4 = fastInnerDenoise(HH4);

% inverse wavelet transform
[LL3] = idwt2(LL4, HL4, LH4, HH4,'db1');
[LL2] = idwt2(LL3, HL3, LH3, HH3,'db1');
[LL1] = idwt2(LL2, HL2, LH2, HH2,'db1');
[rs] = idwt2(LL1, HL1, LH1, HH1,'db1');