#include "mex.h"

#include <math.h>
#include <stdio.h>

// Program framework for input, output and processing
// usage:
//      input = zeros(2, 10)
//      input(1, :) = 1:10
//      input(2, :) = 10:-1:1
//      mex test3.c
//      a = test3(input)
// note:  type  all commands above in Matlab Command Window
int w[4];
int deltaW[4];
double delta=5;
double powDelta;
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    int i, j, k;

    // input
    int input_dim_x;
    int input_dim_y;
    double *in;  // pointer to process content of the input

    // output
    int output_dimension[2];  // note: you should specify output dimension
    int output_dim_x;
    int output_dim_y;
    double *out;
    int z, count, x, y, step, sx, sy, ex, ey, temp;
    double sum1, tmpval;
    powDelta = delta*delta;

    /* -------------------------------- */

    /* NECESSARY  (input processing) */

    in = mxGetPr(prhs[0]);  // get data pointer
    // mx: Matrix
    // P: Pointer
    // r: real
    // mxGetPr() has a counterprt mxGetPi();
    input_dim_x = mxGetM(prhs[0]);
    input_dim_y = mxGetN(prhs[0]);

    /* -------------------------------- */

    /* NECESSARY  (output allocation) */

    // specify output matrix's dimension
    output_dim_x = input_dim_x;
    output_dim_y = input_dim_y;
    output_dimension[0] = output_dim_x; // mxCreateNumericArray() required
    output_dimension[1] = output_dim_y;

    // Allocate the output matrix
    plhs[0] = mxCreateNumericArray(
        2,
        output_dimension,
        mxDOUBLE_CLASS,
        mxREAL);

    // Get output matrix's data pointer
    out = mxGetPr(plhs[0]);  // just point at the start


    /* -------------------------------- */

    /* NECESSARY (data processing) */
w[0]=1;w[1]=2; w[2]=3;w[3]=4;
    // Copy and add 1

    for(i=0; i<output_dim_x; i++)
        for(j=0; j<output_dim_y; j++)
    {
        double minDelta=9999999;
            for ( z=0; z<4; z++)
            {
                int step = w[z];
                sx=i-step;
                ex=i+step;
                sy=j-step;
                ey=j+step;
                if (sx<0) sx=0;
                if (ex>=output_dim_x) ex=output_dim_x-1;
                if (sy<0) sy=0;
                if (ey>=output_dim_y) ey=output_dim_y-1;
               
                sum1 = 0;
                count = 0;
                for (x=sx; x<=ex;  x++)
                    for (y=sy; y<=ey; y++)
                    {
                        temp = x + y*input_dim_x;
                        count++;
                        tmpval = (in[temp] *  in[temp])-powDelta;
                        sum1+= tmpval;
                    }
                sum1 = sum1/((double)count);
                if (sum1 <0)
                    sum1 = 0;
                if (minDelta>sum1)
                    minDelta=sum1;
            }
        
                temp = i + j*input_dim_x;
                out[temp] = in[temp] * (minDelta/(minDelta+powDelta));
        }
}
