function rs=innerDenoise(data)
pp=cputime;
[row, col]=size(data);
data=double(data);
delta=  5; %default value by paper.
w=[1 2 3 4];
rs=data;
% Old programming code, slower speed
% for i=1:row
%     for j=1:col
%         deltaW=zeros(1,4);
%         for z=1:length(w)
%             step = w(z);
%             sx = i-step; ex=i+step;
%             sy = j-step; ey=j+step;
%             if (sx<1), sx=1; end
%             if (ex>row), ex=row; end
%             if (sy<1), sy=1; end
%             if (ey>col), ey=col; end
%             deltaW(z) = max(0, mean2((data(sx:ex, sy:ey).^2 - delta^2)));
%         end
%         minDelta = min(deltaW(z));
%         %denoising by Wiener filter
%         rs(i, j) = data(i, j) * (minDelta/(minDelta + delta^2));        
%     end
% end
% disp(['time: ' num2str(cputime-pp)]);


data1 = zeros(row, col, 4);
data1(:,:,1) = ((data.^2)-delta^2);
data1(:,:,2) = ((data.^2)-delta^2);
data1(:,:,3) = ((data.^2)-delta^2);
data1(:,:,4) = ((data.^2)-delta^2);
deltaW=zeros(1,4);
deltaMatrix = zeros(row, col);
rs2=zeros(row, col);
for i=1:row
    for j=1:col
        for z=1:length(w)
            step = w(z);
            sx = i-step; ex=i+step;
            sy = j-step; ey=j+step;
            if (sx<1), sx=1; end
            if (ex>row), ex=row; end
            if (sy<1), sy=1; end
            if (ey>col), ey=col; end
            deltaW(z) = max(0, mean2((data1(sx:ex, sy:ey, z))));
        end
        deltaMatrix(i,j) = min(deltaW(z));
        %denoising by Wiener filter 
    end
end

rs = data .* (deltaMatrix ./ (deltaMatrix + delta^2));    


